
//#include "sysfunc.h"
//#include "fight.h"

int initOSLib(){
//	int i;
	oslInit(0);
	oslInitGfx(OSL_PF_8888, 1);
	oslInitAudio();
	oslSetQuitOnLoadFailure(1);
	oslSetKeyAutorepeatInit(40);
	oslSetKeyAutorepeatInterval(10);
	oslIntraFontInit(INTRAFONT_CACHE_MED);
	return 0;
}

/////////////////////////////Visualizzazioni////////////////
/////////////////////////////Visualizzazioni////////////////
/////////////////////////////Visualizzazioni////////////////

void drawTable(){
	thpl=cfg.turn%cfg.play;
	oslDrawImageXY(table, psx*30, psy*30);
	for(int i=0;i<9;i++){
		for(int j=0;j<16;j++){
			if(w[-psy+i][-psx+j]!=0){
				oslDrawFillRect(j*30, i*30, (j+1)*30, (i+1)*30, RGBA(243, 231, 197, 128));
				oslDrawChar(j*30+10, i*30+10, w[-psy+i][-psx+j]);
			}
		}
	}
	if(start==0){
		oslSetFont(font);
		if(osl_pad.held.R){
			oslDrawFillRect(0, 0, 120, 50, RGBA(0, 0, 255, 128));
			oslDrawStringf(10, 10, "Player %i\nturn: %i", thpl+1, cfg.turn+1);
			
			oslDrawFillRect(310, 0, 480, 30+cfg.play*25+10, RGBA(0, 0, 255, 128));
			oslDrawStringf(310+20, 10, "%i:%i:%i", _sec[0]/3600%24, _sec[0]/60%60, _sec[0]%60);
			for(int i=0;i<cfg.play;i++){
				oslDrawStringf(310+10, 30+i*25, "%s %i: %i", menu[5], i+1, pl[i].point);
			}
			
			oslDrawFillRect(0, 272/2+30, 480, 272, RGBA(0, 0, 255, 128));
			char ct1;
			for(int i=0;i<pl[thpl].lN;i++){
				ct1=pl[thpl].l[i];
				if(ct1=='0' || ct1=='1'){
					oslSetFont(font2);
					oslDrawStringf(30+i*30, 200, "sc%c", ct1);
					oslSetFont(font);
				}else{
					oslDrawStringf(30+i*30, 200, "%c", ct1);
				}
			}
			oslDrawImageXY(selI, 25+sel[20]*30, 190);
			oslDrawFillRect(25+sel[20]*30+29, 190, 25+sel[20]*30+32, 220, RGBA(255, 0, 0, 255));
			oslDrawFillRect(25+pl[thpl].wN*30+29, 190, 25+pl[thpl].wN*30+32, 220, RGBA(255, 0, 0, 255));
			oslDrawStringf(50, 240, "%s:  %s", menu[10], menu[11+pl[thpl].dir]);
			if(action[20]==0){
					  if(osl_pad.pressed.cross){	action[20]=1;	sel[19]=sel[20];
				}else if(osl_pad.pressed.square){	pl[thpl].wN=sel[20];
				}else if(osl_pad.pressed.circle){	action[20]=2;
				}else if(osl_pad.pressed.triangle){ pl[thpl].changeL();
				}else if(osl_pad.pressed.left){		if(--sel[20]<0)				sel[20]=pl[thpl].lN-1;
				}else if(osl_pad.pressed.right){	if(++sel[20]>pl[thpl].lN-1)	sel[20]=0;
				}
			}else if(action[20]==1){
				oslDrawImageXY(selI, 25+sel[19]*30, 190);
					  if(osl_pad.pressed.cross){
					char t=pl[thpl].l[sel[20]];
					pl[thpl].l[sel[20]]=pl[thpl].l[sel[19]];
					pl[thpl].l[sel[19]]=t;
					action[20]=0;
				}else if(osl_pad.pressed.left){		if(--sel[20]<0)				sel[20]=pl[thpl].lN-1;
				}else if(osl_pad.pressed.right){	if(++sel[20]>pl[thpl].lN-1)	sel[20]=0;
				}
			}else if(action[20]==2){
					  if(osl_pad.pressed.up){		pl[thpl].dir=0;
				}else if(osl_pad.pressed.down){		pl[thpl].dir=1;
				}else if(osl_pad.pressed.left){		pl[thpl].dir=2;
				}else if(osl_pad.pressed.right){	pl[thpl].dir=3;
				}else if(osl_pad.pressed.circle){	action[20]=0;
				}
			}
		}else if(osl_pad.held.L){
			oslDrawFillRect(0, 0, 120, 50, RGBA(255, 0, 0, 128));
			oslDrawStringf(10, 10, "Player %i\nturn: %i", thpl+1, cfg.turn+1);
			
			oslDrawFillRect(310, 0, 480, 30+cfg.play*25+10, RGBA(255, 0, 0, 128));
			oslDrawStringf(310+20, 10, "%i:%i:%i", _sec[0]/3600%24, _sec[0]/60%60, _sec[0]%60);
			for(int i=0;i<cfg.play;i++){
				oslDrawStringf(310+10, 30+i*25, "%s %i: %i", menu[5], i+1, pl[i].point);
			}
			
			oslDrawFillRect(0, 272/2+30, 480, 272, RGBA(255, 0, 0, 128));
			oslDrawStringf(40, 200, "%s 1:  %c", menu[15], pl[thpl].scr[0]);
			oslDrawStringf(40, 230, "%s 2:  %c", menu[15], pl[thpl].scr[1]);
			oslDrawString(20, 200+sel[10]*30, ">");
				  if(osl_pad.pressed.up){		if(--sel[10]<0)	sel[10]=1;
			}else if(osl_pad.pressed.down){		if(++sel[10]>1)	sel[10]=0;
			}else if(osl_pad.pressed.left){		if(--pl[thpl].scr[sel[10]]<'A')	 pl[thpl].scr[sel[10]]='Z';
			}else if(osl_pad.pressed.right){	if(++pl[thpl].scr[sel[10]]>'Z')	 pl[thpl].scr[sel[10]]='A';
			}
		}else{
			short	fy=(pl[thpl].dir/2==0?(pl[thpl].dir%2?1:-1):0);
			short	fx=(pl[thpl].dir/2==1?(pl[thpl].dir%2?1:-1):0);
			oslDrawImageXY(selI, (px+psx)*30, (py+psy)*30);
			for(int i=1;i<=pl[thpl].wN;i++)
				oslDrawImageXY(selJ, (px+fx*i+psx)*30, (py+fy*i+psy)*30);
				  if(osl_pad.pressed.down){		py++;	if(py>16)	py=16;	if(py+psy>8)	psy--;
			}else if(osl_pad.pressed.up){		py--;	if(py<0)	py=0;	if(py+psy<0)	psy++;
			}else if(osl_pad.pressed.right){	px++;	if(px>16)	px=16;	if(px>15)		psx=-1;
			}else if(osl_pad.pressed.left){		px--;	if(px<0)	px=0;	if(px<1)		psx=0;
			}else if(osl_pad.pressed.start){	start=1;
			}else if(osl_pad.pressed.cross){	pl[thpl].setW();
			}
		}
	}else{
		oslSetFont(font2);
		oslDrawFillRect(0, 150, 480, 272, RGBA(255, 0, 0, 128+64+32));
		oslDrawStringf(20, 160, "Pause Menu");
		oslDrawStringf(20, 180, "O to Start Menu");
		oslSetFont(font);
		
			  if(osl_pad.pressed.start){	start=0;
		}else if(osl_pad.pressed.circle){	action[0]=0;	start=0;
		}
	}
}





void mixS(){
	int s=remS;
	srand(clock()*time(NULL));
	int a=rand()%10000;
//	int s=strlen(L);
	srand(clock()*time(NULL));
	int b=rand()%10000;
	for(int i=0;i<a;i++){
		int i1=rand()%s;
		int i2=rand()%(a+(b+1)*i)%s;
		char t=S[i1];
		S[i1]=S[i2];
		S[i2]=t;
	}
}

void setS(){
	remS=strlen(L);
	memcpy(S, L, remS);
	mixS();
	mixS();
	mixS();
}

void Start(){
	chT();
	pl=new player[4];
	setS();
	cout<<endl<<L<<endl<<S<<endl;
	for(int i=0;i<cfg.play;i++)
		pl[i].takeL();
	for(int i=0;i<cfg.play;i++){
		cout<<pl[i].l<<endl;
	}
	cout<<S<<endl;
	ft=1;
	
}

void __tempo(){
	_sec[2]=time(NULL);
	if(_sec[2]>_sec[1]){
		_sec[0]++;
		_sec[1]=_sec[2];
	}

}


